﻿Liquid_Wealth.AuctioneerAddons = {
  ["auc-advanced"] = { name = "Auc-Advanced", func = "GetAucAdv", check = "Auc-Advanced" },
  ["auctioneer"] = { name = "Auctioneer", func = "GetAuc4", check = "Auctioneer" },
  ["auctionator"] = { name = "Auctionator", func = "GetAuctionator", check = "Auctionator" },
  ["auctionlite"] = { name = "AuctionLite", func = "GetAuctionLite", check = "AuctionLite" },
  ["auctionmaster"] = { name = "AuctionMaster", func = "GetAuctionMaster", check = "AuctionMaster" },
  ["tradeskillmaster"] = { name = "TradeSkillMaster", func = "GetTradeSkillMaster", check = "TradeSkillMaster" },
  ["theunderminejournalge"] = { name = "TheUndermineJournalGE", func = "GetTheUndermineJournalGE", check = "TheUndermineJournalGE", title="The Undermine Journal GE : Market Average" },
  --["theunderminejournalge"] = { name = "theunderminejournalge", func = "GetTheUndermineJournalGE", check = "theunderminejournalge", title="The Undermine Journal GE : Market Median" },
};

Liquid_Wealth.AuctionCheckFullDatebaseFullScan = {
  ["auctionmaster"] = { name = "AuctionMaster", func = "GetAuctionMaster_CheckFullScan", check = "AuctionMaster" },
  ["auc-advanced"] = { name = "Auc-Advanced", func = "GetAucAdvanced_CheckFullScan", check = "Auc-Advanced" },
  ["theunderminejournalge"] = { name = "theunderminejournalge", func = "GetTheUndermineJournal_CheckFullScan", check = "theunderminejournalge" },
  ["tradeskillmaster"] = { name = "TradeSkillMaster", func = "GetTradeSkillMaster_CheckFullScan", check = "TradeSkillMaster" },
};

function Liquid_Wealth:GetTradeSkillMaster(itemLink)
	local _, _, Color, Ltype, itemID, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	local marketValue = TSMAPI:GetItemValue(itemLink,"DBMarket")
	return marketValue
end

function Liquid_Wealth:GetTradeSkillMaster_CheckFullScan()
	--return TSMAPI:GetData("GetLastCompleteScan")
	--return TSM:GetLastScanTime()
	local TSMDB = LibStub("AceDB-3.0"):New("TradeSkillMaster_AuctionDBDB")
	return TSMDB.factionrealm.lastCompleteScan
end

function Liquid_Wealth:GetTheUndermineJournal_CheckFullScan()
	local timev2 = GetAddOnMetadata("TheUndermineJournalGE", "Version")
	local y,m,d=string.match(timev2,"%d+.%d+.(%d%d%d%d)(%d%d)(%d%d)")
	local h=0
	local mi=0
	local s=0
	return time({['year']=y,['month']=m,['day']=d,['hour']=h,['min']=mi,['sec']=s,['isdst']=nil}) 
end

--TheUndermineJournalGE
function Liquid_Wealth:GetTheUndermineJournalGE(itemLink)
	local _, _, Color, Ltype, itemID, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	--o['age'] = num of seconds since import
	--o['marketmedian'] = median market price over all realms (among most recent market prices)
	--o['marketaverage'] = average market price over the past 2 weeks over all realms
	--o['marketstddev'] = market price standard deviation over the past 2 weeks over all realms
	return (TUJMarketInfo(tonumber(itemID)) or {}).marketaverage
end

--Auctionator
function Liquid_Wealth:GetAuctionator(itemLink)
  return Atr_GetAuctionBuyout(itemLink);
end

-- Auc Advanced
function Liquid_Wealth:GetAucAdv(itemLink)
  sellPrice, _ = AucAdvanced.API.GetMarketValue(itemLink, AucAdvanced.GetFaction());
  return sellPrice;
end

-- Auctioneer 4.0
function Liquid_Wealth:GetAuc4(itemLink)
  local _, _, buyMedian = Auctioneer.Statistic.GetSuggestedResale(Auctioneer.ItemDB.CreateItemKeyFromLink(itemLink), nil, 1);
  return buyMedian;
end

-- AuctionLite
function Liquid_Wealth:GetAuctionLite(itemLink)
  return AuctionLite:GetAuctionValue(itemLink)
end

--Auc Advanced Check Last Scan
function Liquid_Wealth:GetAucAdvanced_CheckFullScan()
 if IsAddOnLoaded(string.lower("Auc-Advanced")) and IsAddOnLoaded(string.lower("Auc-ScanData")) then --Check To See If Addon InList Is Enabled
    local englishFaction, _ = UnitFactionGroup("player")
    local realmName = GetRealmName()
    if AucScanData.scans[realmName][englishFaction].scanstats.LastFullScan ~= nil then
      local timeToConvert = AucScanData.scans[realmName][englishFaction].scanstats.LastFullScan
      local convertedTimestamp = timeToConvert
      return convertedTimestamp
    else
      return nil
    end
  elseif not IsAddOnLoaded(string.lower("Auc-Advanced")) or not IsAddOnLoaded(string.lower("Auc-ScanData"))  then
    return "Auc-ScanData Not Loaded"
  else
    return nil
  end
end

-- AuctionMaster Check Last Scan
function Liquid_Wealth:GetAuctionMaster_CheckFullScan()
  if IsAddOnLoaded(string.lower("AuctionMaster")) then --Check To See If Addon InList Is Enabled
    local amdb = LibStub("AceDB-3.0"):New("VendorDb")
    local scan = amdb:RegisterNamespace("Scanner2");
    local pattern = "(%d+)/(%d+)/(%d+) (%d+):(%d+):(%d+)"
    if scan.factionrealm.lastScan ~= nil then
      local timeToConvert = scan.factionrealm.lastScan
      local runmonth, runday, runyear, runhour, runminute, runseconds = timeToConvert:match(pattern)
      runmonth = tonumber(runmonth)
      runday = tonumber(runday)
      runyear = tonumber(runyear) + 2000 --Bad Fix to get 4 digit year
      runhour = tonumber(runhour)
      runminute = tonumber(runminute)
      runseconds = tonumber(runseconds)
      timetable = { hour = runhour, min = runminute, sec = runseconds, day = runday, month = runmonth, year = runyear }
      local convertedTimestamp = time(timetable)
      return convertedTimestamp
    else
      return nil
    end
  else
    return nil
  end
end

-- AuctionMaster
function Liquid_Wealth:GetAuctionMaster(itemLink)
  local avgBid, avgBuy, numBid, numBuy = AucMasGetAuctionInfo(itemLink, false)
  return avgBuy or 0, numBuy or 0
end

function Liquid_Wealth:GetAHLastTimeScaned()
  local lastScanTimeDate
  if self.AuctionCheckFullDatebaseFullScan[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)] then
    lastScanTimeDate = self[self.AuctionCheckFullDatebaseFullScan[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self); --Runs The Function In The List
  else
    lastScanTimeDate = nil
  end
  return lastScanTimeDate
end


function Liquid_Wealth:AucDeposit(itemLink)
  -- local tempTotal=0;
  -- local itemsPrice=0;
  -- if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedVendorAddon) then --Check To See If Addon InList Is Enabled
  -- itemsPrice = self[self.vendoraddons[string.lower(self.db.profile.selectedVendorAddon)].func](self,itemLink); --Runs The Function In The List
  -- if (Liquid_Wealth.db.profile.selectedAhFaction=="factioned") then
  -- if(Liquid_Wealth.db.profile.selectedAhTime==12) then
  -- tempTotal=0.15*itemsPrice
  -- elseif(Liquid_Wealth.db.profile.selectedAhTime==24) then
  -- tempTotal=2*(0.15*itemsPrice)
  -- elseif(Liquid_Wealth.db.profile.selectedAhTime==48) then
  -- tempTotal=2*(0.15*itemsPrice)
  -- end
  -- elseif(Liquid_Wealth.db.profile.selectedAhFaction=="neutral") then
  -- if(Liquid_Wealth.db.profile.selectedAhTime==12) then
  -- tempTotal=0.75*itemsPrice
  -- elseif(Liquid_Wealth.db.profile.selectedAhTime==24) then
  -- tempTotal=2*(0.75*itemsPrice)
  -- elseif(Liquid_Wealth.db.profile.selectedAhTime==48) then
  -- tempTotal=2*(0.75*itemsPrice)
  -- end
  -- end
  -- end
  -- return tempTotal;
end

function Liquid_Wealth:GetBagValueAuction(bagId, ptFilter)
  local bagTotal = 0; -- Using Auctioneer buyout median price
  local bagFilterTotal = 0;
  if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then
    local bagSlots = GetContainerNumSlots(bagId);
    if (bagSlots > 0) then
      local bagName = GetBagName(bagId);
      -- Need To Check For Item SoulBound & QuestItems BC They Might Not Be Vendered Or AH'ed
      for slot = 1, bagSlots do
        local PriceTotal = 0;
        local itemsPrice = 0;
        local itemsDeositCost = 0;
        local itemLink = GetContainerItemLink(bagId, slot);
        if (itemLink) then
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
			if Liquid_Wealth:IsItemSoulbound(bagId, slot) then
				--The Item is soulbound so we have to call a new method to allow to add that to the vender.
			else
				itemsPrice = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
			end
			if (itemsPrice) then
				PriceTotal = itemCount * itemsPrice;
				bagTotal = bagTotal + floor(PriceTotal);
				--if (Liquid_Wealth.db.profile.AucDeposit) then
				--itemsDeositCost=itemsDeositCost+(itemCount*floor(Liquid_Wealth:AucDeposit(itemLink)))
				--end
			end
        end
      end
    end
  end
  return bagTotal,bagFilterTotal;
end

function Liquid_Wealth:GetItemValueAuction(itemLink)
  local itemsPrice = 0;
  if (itemLink) and IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then --Check To See If Addon InList Is Enabled
    itemsPrice = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
  end
  return itemsPrice or 0;
end
